Verify tags: Use suite tags
[csit.git] / resources / libraries / bash / function / common.sh
index 54a013e..01873d3 100644 (file)
@@ -481,11 +481,6 @@ function get_test_code () {
             NODENESS="3n"
             FLAVOR="tsh"
             ;;
-        *)
-            # Fallback to 3-node Haswell by default (backward compatibility)
-            NODENESS="3n"
-            FLAVOR="hsw"
-            ;;
     esac
 }
 
@@ -526,7 +521,8 @@ function get_test_tag_string () {
         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
         if [[ -z "${TEST_TAG_STRING-}" ]]; then
             # Probably we got a base64 encoded comment.
-            comment=$(base64 --decode <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
+            comment="${GERRIT_EVENT_COMMENT_TEXT}"
+            comment=$(base64 --decode <<< "${comment}" || true)
             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
         fi
@@ -538,9 +534,6 @@ function get_test_tag_string () {
             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
                 export GRAPH_NODE_VARIANT="skx"
                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
-            elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
-                export GRAPH_NODE_VARIANT="hsw"
-                TEST_TAG_STRING="${test_tag_array[@]:1}" || true
             fi
         fi
     fi
@@ -606,6 +599,34 @@ function move_archives () {
 }
 
 
+function prepare_topology () {
+
+    # Prepare virtual testbed topology if needed based on flavor.
+
+    # Variables read:
+    # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
+    # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
+    # Functions called:
+    # - die - Print to stderr and exit.
+    # - terraform_init - Terraform init topology.
+    # - terraform_apply - Terraform apply topology.
+
+    set -exuo pipefail
+
+    case_text="${NODENESS}_${FLAVOR}"
+    case "${case_text}" in
+        "2n_aws")
+            terraform_init || die "Failed to call terraform init."
+            terraform_apply || die "Failed to call terraform apply."
+            ;;
+        "3n_aws")
+            terraform_init || die "Failed to call terraform init."
+            terraform_apply || die "Failed to call terraform apply."
+            ;;
+    esac
+}
+
+
 function reserve_and_cleanup_testbed () {
 
     # Reserve physical testbed, perform cleanup, register trap to unreserve.
@@ -808,7 +829,7 @@ function select_tags () {
         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
             default_nic="nic_intel-xxv710"
             ;;
-        *"3n-hsw"* | *"2n-tx2"* | *"mrr-daily-master")
+        *"2n-tx2"* | *"mrr-daily-master")
             default_nic="nic_intel-xl710"
             ;;
         *"2n-aws"* | *"3n-aws"*)
@@ -827,11 +848,13 @@ function select_tags () {
     awk_nics_sub_cmd+='gsub("x520-da2","10ge2p1x520");'
     awk_nics_sub_cmd+='gsub("x553","10ge2p1x553");'
     awk_nics_sub_cmd+='gsub("cx556a","100ge2p1cx556a");'
+    awk_nics_sub_cmd+='gsub("e810cq","100ge2p1e810cq");'
     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
     awk_nics_sub_cmd+='gsub("vic1385","40ge2p1vic1385");'
     awk_nics_sub_cmd+='gsub("nitro-50g","50ge1p1ENA");'
     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
+    awk_nics_sub_cmd+='else if ($9 =="drv_af_xdp") drv ="af-xdp-";'
     awk_nics_sub_cmd+='else drv="";'
     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-"$1"-" drv $11"-"$5'
 
@@ -879,11 +902,11 @@ function select_tags () {
             if [[ -z "${TEST_TAG_STRING-}" ]]; then
                 # If nothing is specified, we will run pre-selected tests by
                 # following tags.
-                test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
-                                "mrrAND${default_nic}AND1cAND78bANDip6base"
-                                "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
-                                "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
-                                "!dot1q" "!drv_avf")
+                test_tag_array=("mrrAND${default_nic}AND1cAND64bANDethip4-ip4base"
+                                "mrrAND${default_nic}AND1cAND78bANDethip6-ip6base"
+                                "mrrAND${default_nic}AND1cAND64bANDeth-l2bdbasemaclrn"
+                                "mrrAND${default_nic}AND1cAND64bANDeth-l2xcbase"
+                                "!drv_af_xdp" "!drv_avf")
             else
                 # If trigger contains tags, split them into array.
                 test_tag_array=(${TEST_TAG_STRING//:/ })
@@ -896,7 +919,6 @@ function select_tags () {
     #
     # Reasons for blacklisting:
     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
-    # TODO: Add missing reasons here (if general) or where used (if specific).
     case "${TEST_CODE}" in
         *"2n-skx"*)
             test_tag_array+=("!ipsechw")
@@ -935,21 +957,9 @@ function select_tags () {
             test_tag_array+=("!drv_avf")
             test_tag_array+=("!ipsechw")
             ;;
-        *"3n-hsw"*)
-            test_tag_array+=("!drv_avf")
-            # All cards have access to QAT. But only one card (xl710)
-            # resides in same NUMA as QAT. Other cards must go over QPI
-            # which we do not want to even run.
-            test_tag_array+=("!ipsechwNOTnic_intel-xl710")
-            ;;
         *"2n-aws"* | *"3n-aws"*)
             test_tag_array+=("!ipsechw")
             ;;
-        *)
-            # Default to 3n-hsw due to compatibility.
-            test_tag_array+=("!drv_avf")
-            test_tag_array+=("!ipsechwNOTnic_intel-xl710")
-            ;;
     esac
 
     # We will add excluded NICs.
@@ -999,7 +1009,7 @@ function select_topology () {
 
     # Variables read:
     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
-    # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
+    # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
     # - CSIT_DIR - Path to existing root of local CSIT git repository.
     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
     # Variables set:
@@ -1012,8 +1022,6 @@ function select_topology () {
 
     case_text="${NODENESS}_${FLAVOR}"
     case "${case_text}" in
-        # TODO: Move tags to "# Blacklisting certain tags per topology" section.
-        # TODO: Double link availability depends on NIC used.
         "1n_vbox")
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
             TOPOLOGIES_TAGS="2_node_single_link_topo"
@@ -1046,10 +1054,6 @@ function select_topology () {
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
             TOPOLOGIES_TAGS="3_node_single_link_topo"
             ;;
-        "3n_hsw")
-            TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
-            TOPOLOGIES_TAGS="3_node_single_link_topo"
-            ;;
         "3n_tsh")
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
             TOPOLOGIES_TAGS="3_node_single_link_topo"
@@ -1067,7 +1071,7 @@ function select_topology () {
             TOPOLOGIES_TAGS="3_node_single_link_topo"
             ;;
         *)
-            # No falling back to 3n_hsw default, that should have been done
+            # No falling back to default, that should have been done
             # by the function which has set NODENESS and FLAVOR.
             die "Unknown specification: ${case_text}"
     esac
@@ -1138,6 +1142,31 @@ function select_vpp_device_tags () {
     done
 }
 
+
+function set_environment_variables () {
+
+    # Depending on testbed topology, overwrite defaults set in the
+    # resources/libraries/python/Constants.py file
+    #
+    # Variables read:
+    # - TEST_CODE - String affecting test selection, usually jenkins job name.
+    # Variables set:
+    # See specific cases
+
+    set -exuo pipefail
+
+    case "${TEST_CODE}" in
+        *"2n-aws"* | *"3n-aws"*)
+            # T-Rex 2.88 workaround for ENA NICs
+            export TREX_RX_DESCRIPTORS_COUNT=1024
+            export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
+            # Settings to prevent duration stretching
+            export PERF_TRIAL_STL_DELAY=0.1
+            ;;
+    esac
+}
+
+
 function untrap_and_unreserve_testbed () {
 
     # Use this as a trap function to ensure testbed does not remain reserved.
@@ -1172,6 +1201,13 @@ function untrap_and_unreserve_testbed () {
         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
         }
+        case "${TEST_CODE}" in
+            *"2n-aws"* | *"3n-aws"*)
+                terraform_destroy || die "Failed to call terraform destroy."
+                ;;
+            *)
+                ;;
+        esac
         WORKING_TOPOLOGY=""
         set -eu
     fi